Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.type
Class ExternalObjectType

    java.lang.Object
      net.sf.saxon.type.ExternalObjectType

All Implemented Interfaces:
  AtomicType, ItemType, SchemaComponent, SchemaType, java.io.Serializable, SimpleType

public class ExternalObjectType
extends java.lang.Object
implements AtomicType, java.io.Serializable

This class represents the type of an external Java object returned by an extension function, or supplied as an external variable/parameter.

See Also:
  Serialized Form

Field Summary
`static ExternalObjectType` | `GENERAL_EXTERNAL_OBJECT_TYPE`

Fields inherited from interface net.sf.saxon.type.SchemaType
`DERIVATION_EXTENSION, DERIVATION_LIST, DERIVATION_RESTRICTION, DERIVATION_UNION, DERIVE_BY_SUBSTITUTION`

Fields inherited from interface net.sf.saxon.type.SchemaComponent
`FIXED_UP, INCOMPLETE, INVALID, UNVALIDATED, VALIDATED, VALIDATING`

Constructor Summary
`ExternalObjectType(java.lang.Class javaClass)`

Method Summary
`boolean` | `allowsDerivation(int derivation)` Determines whether derivation (of a particular kind) from this type is allowed, based on the "final" property
`void` | `analyzeContentExpression(Expression expression, int kind, StaticContext env)` Analyze an expression to see whether the expression is capable of delivering a value of this type.
`static void` | `analyzeContentExpression(SimpleType simpleType, Expression expression, StaticContext env, int kind)` Analyze an expression to see whether the expression is capable of delivering a value of this type.
`java.lang.CharSequence` | `applyWhitespaceNormalization(java.lang.CharSequence value)` Apply the whitespace normalization rules for this simple type
`Value` | `atomize(NodeInfo node)` Get the typed value of a node that is annotated with this schema type.
`AtomicType` | `getAtomizedItemType()` Get the item type of the atomic values that will be produced when an item of this type is atomized
`SchemaType` | `getBaseType()` Returns the base type that this type inherits from.
`int` | `getBlock()` Returns the value of the 'block' attribute for this type, as a bit-signnificant integer with fields such as `SchemaType.DERIVATION_LIST` and `SchemaType.DERIVATION_EXTENSION`
`SchemaType` | `getBuiltInBaseType()` Returns the built-in base type this type is derived from.
`AtomicType` | `getCommonAtomicType()` Get the most specific possible atomic type that all items in this SimpleType belong to
`int` | `getDerivationMethod()` Gets the integer code of the derivation method used to derive this type from its parent.
`java.lang.String` | `getDescription()` Get a description of this type for use in error messages.
`java.lang.String` | `getDisplayName()` Get the display name of the type: that is, a lexical QName with an arbitrary prefix
`int` | `getFingerprint()` Get the fingerprint of the name of this type
`java.lang.Class` | `getJavaClass()`
`SchemaType` | `getKnownBaseType()` Returns the base type that this type inherits from.
`int` | `getNameCode()` Get the namecode of the name of this type.
`ItemType` | `getPrimitiveItemType()` Get the primitive item type corresponding to this item type.
`int` | `getPrimitiveType()` Get the primitive type corresponding to this item type.
`ItemType` | `getSuperType(TypeHierarchy th)` Get the type from which this item type is derived by restriction.
`SequenceIterator` | `getTypedValue(java.lang.CharSequence value, NamespaceResolver resolver, NameChecker nameChecker)` Get the typed value corresponding to a given string value, assuming it is valid against this type
`SequenceIterator` | `getTypedValue(NodeInfo node)` Get the typed value of a node that is annotated with this schema type
`int` | `getValidationStatus()` Get the validation status - always valid
`int` | `getWhitespaceAction(TypeHierarchy th)` Determine the whitespace normalization required for values of this type
`boolean` | `isAtomicType()` Test whether this Simple Type is an atomic type
`boolean` | `isBuiltIn()`
`boolean` | `isComplexType()` Test whether this SchemaType is a complex type
`boolean` | `isListType()` Returns true if this type is derived by list, or if it is derived by restriction from a list type, or if it is a union that contains a list as one of its members
`boolean` | `isNamespaceSensitive()` Test whether this simple type is namespace-sensitive, that is, whether it is derived from xs:QName or xs:NOTATION
`boolean` | `isSameType(SchemaType other)` Test whether this is the same type as another type.
`boolean` | `isSimpleType()` Returns true if this SchemaType is a SimpleType
`void` | `isTypeDerivationOK(SchemaType type, int block)` Check that this type is validly derived from a given type
`boolean` | `isUnionType()` Return true if this type is a union type (that is, if its variety is union)
`AtomicValue` | `makeDerivedValue(AtomicValue primValue, java.lang.CharSequence lexicalValue, boolean validate)` Factory method to create values of a derived atomic type.
`boolean` | `matchesItem(Item item, XPathContext context, boolean allowURIPromotion)` Test whether a given item conforms to this type
`java.lang.String` | `toString()`
`java.lang.String` | `toString(NamePool pool)` Produce a representation of this type name for use in error messages.
`ValidationException` | `validateContent(java.lang.CharSequence value, NamespaceResolver nsResolver, NameChecker nameChecker)` Check whether a given input string is valid according to this SimpleType

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### GENERAL_EXTERNAL_OBJECT_TYPE

    public static final ExternalObjectType GENERAL_EXTERNAL_OBJECT_TYPE

Constructor Detail

### ExternalObjectType

    public ExternalObjectType(java.lang.Class javaClass)

Method Detail

### getCommonAtomicType

    public AtomicType getCommonAtomicType()

  Get the most specific possible atomic type that all items in this SimpleType belong to

  Specified by:
    `getCommonAtomicType` in interface `SimpleType`
  Returns:
    the lowest common supertype of all member types

### getValidationStatus

    public final int getValidationStatus()

  Get the validation status - always valid

  Specified by:
    `getValidationStatus` in interface `SchemaComponent`
  Returns:
    one of the values `SchemaComponent.UNVALIDATED`, `SchemaComponent.VALIDATING`, `SchemaComponent.VALIDATED`, `SchemaComponent.INVALID`, `SchemaComponent.INCOMPLETE`

### getBlock

    public final int getBlock()

  Returns the value of the 'block' attribute for this type, as a bit-signnificant integer with fields such as `SchemaType.DERIVATION_LIST` and `SchemaType.DERIVATION_EXTENSION`

  Specified by:
    `getBlock` in interface `SchemaType`
  Returns:
    the value of the 'block' attribute for this type

### getDerivationMethod

    public final int getDerivationMethod()

  Gets the integer code of the derivation method used to derive this type from its parent. Returns zero for primitive types.

  Specified by:
    `getDerivationMethod` in interface `SchemaType`
  Returns:
    a numeric code representing the derivation method, for example `SchemaType.DERIVATION_RESTRICTION`

### allowsDerivation

    public final boolean allowsDerivation(int derivation)

  Determines whether derivation (of a particular kind) from this type is allowed, based on the "final" property

  Specified by:
    `allowsDerivation` in interface `SchemaType`
  Parameters:
    `derivation` - the kind of derivation, for example `SchemaType.DERIVATION_LIST`
  Returns:
    true if this kind of derivation is allowed

### getNameCode

    public int getNameCode()

  Get the namecode of the name of this type. This includes the prefix from the original type declaration: in the case of built-in types, there may be a conventional prefix or there may be no prefix.

  Specified by:
    `getNameCode` in interface `SchemaType`

### isComplexType

    public final boolean isComplexType()

  Test whether this SchemaType is a complex type

  Specified by:
    `isComplexType` in interface `SchemaType`
  Returns:
    true if this SchemaType is a complex type

### getBaseType

    public final SchemaType getBaseType()

  Returns the base type that this type inherits from. This method can be used to get the base type of a type that is known to be valid. If this type is a Simpletype that is a built in primitive type then null is returned.

  Specified by:
    `getBaseType` in interface `SchemaType`
  Returns:
    the base type.
  Throws:
    `java.lang.IllegalStateException` - if this type is not valid.

### getPrimitiveItemType

    public ItemType getPrimitiveItemType()

  Get the primitive item type corresponding to this item type. For item(), this is Type.ITEM. For node(), it is Type.NODE. For specific node kinds, it is the value representing the node kind, for example Type.ELEMENT. For anyAtomicValue it is Type.ATOMIC_VALUE. For numeric it is Type.NUMBER. For other atomic types it is the primitive type as defined in XML Schema, except that INTEGER is considered to be a primitive type.

  Specified by:
    `getPrimitiveItemType` in interface `ItemType`

### getPrimitiveType

    public int getPrimitiveType()

  Get the primitive type corresponding to this item type. For item(), this is Type.ITEM. For node(), it is Type.NODE. For specific node kinds, it is the value representing the node kind, for example Type.ELEMENT. For anyAtomicValue it is Type.ATOMIC. For numeric it is Type.NUMBER. For other atomic types it is the primitive type as defined in XML Schema, except that INTEGER is considered to be a primitive type.

  Specified by:
    `getPrimitiveType` in interface `ItemType`

### toString

    public java.lang.String toString(NamePool pool)

  Produce a representation of this type name for use in error messages. Where this is a QName, it will use conventional prefixes

  Specified by:
    `toString` in interface `ItemType`

### getAtomizedItemType

    public AtomicType getAtomizedItemType()

  Get the item type of the atomic values that will be produced when an item of this type is atomized

  Specified by:
    `getAtomizedItemType` in interface `ItemType`

### getKnownBaseType

    public SchemaType getKnownBaseType()

  Returns the base type that this type inherits from. This method can be used to get the base type of a type that is known to be valid. If this type is a Simpletype that is a built in primitive type then null is returned.

  Returns:
    the base type.
  Throws:
    `java.lang.IllegalStateException` - if this type is not valid.

### isSameType

    public boolean isSameType(SchemaType other)

  Test whether this is the same type as another type. They are considered to be the same type if they are derived from the same type definition in the original XML representation (which can happen when there are multiple includes of the same file)

  Specified by:
    `isSameType` in interface `SchemaType`

### getDescription

    public java.lang.String getDescription()

  Description copied from interface: `SchemaType`
  Get a description of this type for use in error messages. This is the same as the display name in the case of named types; for anonymous types it identifies the type by its position in a source schema document.

  Specified by:
    `getDescription` in interface `SchemaType`
  Returns:
    text identifing the type, for use in a phrase such as "the type XXXX".

### isTypeDerivationOK

    public void isTypeDerivationOK(SchemaType type,
                                   int block)
                            throws SchemaException,
                                   ValidationException

  Check that this type is validly derived from a given type

  Specified by:
    `isTypeDerivationOK` in interface `SchemaType`
  Parameters:
    `type` - the type from which this type is derived
    `block` - the derivations that are blocked by the relevant element declaration
  Throws:
    `SchemaException` - if the derivation is not allowed
    `ValidationException`

### isSimpleType

    public final boolean isSimpleType()

  Returns true if this SchemaType is a SimpleType

  Specified by:
    `isSimpleType` in interface `SchemaType`
  Returns:
    true (always)

### isAtomicType

    public boolean isAtomicType()

  Test whether this Simple Type is an atomic type

  Specified by:
    `isAtomicType` in interface `SimpleType`
  Returns:
    true, this is considered to be an atomic type

### isListType

    public boolean isListType()

  Returns true if this type is derived by list, or if it is derived by restriction from a list type, or if it is a union that contains a list as one of its members

  Specified by:
    `isListType` in interface `SimpleType`
  Returns:
    true if this is a list type

### isUnionType

    public boolean isUnionType()

  Return true if this type is a union type (that is, if its variety is union)

  Specified by:
    `isUnionType` in interface `SimpleType`
  Returns:
    true for a union type

### getWhitespaceAction

    public int getWhitespaceAction(TypeHierarchy th)

  Determine the whitespace normalization required for values of this type

  Specified by:
    `getWhitespaceAction` in interface `SimpleType`
  Parameters:
    `th` -
  Returns:
    one of PRESERVE, REPLACE, COLLAPSE

### applyWhitespaceNormalization

    public java.lang.CharSequence applyWhitespaceNormalization(java.lang.CharSequence value)
                                                        throws ValidationException

  Apply the whitespace normalization rules for this simple type

  Parameters:
    `value` - the string before whitespace normalization
  Returns:
    the string after whitespace normalization
  Throws:
    `ValidationException`

### getBuiltInBaseType

    public SchemaType getBuiltInBaseType()
                                  throws ValidationException

  Returns the built-in base type this type is derived from.

  Specified by:
    `getBuiltInBaseType` in interface `SimpleType`
  Returns:
    the first built-in type found when searching up the type hierarchy
  Throws:
    `ValidationException`

### isNamespaceSensitive

    public boolean isNamespaceSensitive()

  Test whether this simple type is namespace-sensitive, that is, whether it is derived from xs:QName or xs:NOTATION

  Specified by:
    `isNamespaceSensitive` in interface `SimpleType`
  Returns:
    true if this type is derived from xs:QName or xs:NOTATION

### getTypedValue

    public final SequenceIterator getTypedValue(NodeInfo node)

  Get the typed value of a node that is annotated with this schema type

  Specified by:
    `getTypedValue` in interface `SchemaType`
  Parameters:
    `node` - the node whose typed value is required
  Returns:
    an iterator over the items making up the typed value of this node. The objects returned by this SequenceIterator will all be of type `AtomicValue`

### atomize

    public Value atomize(NodeInfo node)
                  throws XPathException

  Get the typed value of a node that is annotated with this schema type. The result of this method will always be consistent with the method `getTypedValue(net.sf.saxon.om.NodeInfo)`. However, this method is often more convenient and may be more efficient, especially in the common case where the value is expected to be a singleton.

  Specified by:
    `atomize` in interface `SchemaType`
  Parameters:
    `node` - the node whose typed value is required
  Returns:
    the typed value.
  Throws:
    `XPathException`
  Since:
    8.5

### getTypedValue

    public SequenceIterator getTypedValue(java.lang.CharSequence value,
                                          NamespaceResolver resolver,
                                          NameChecker nameChecker)
                                   throws ValidationException

  Get the typed value corresponding to a given string value, assuming it is valid against this type

  Specified by:
    `getTypedValue` in interface `SimpleType`
  Parameters:
    `value` - the string value
    `resolver` - a namespace resolver used to resolve any namespace prefixes appearing in the content of values. Can supply null, in which case any namespace-sensitive content will be rejected.
    `nameChecker` -
  Returns:
    an iterator over the atomic sequence comprising the typed value. The objects returned by this SequenceIterator will all be of type `AtomicValue`
  Throws:
    `ValidationException`

### makeDerivedValue

    public AtomicValue makeDerivedValue(AtomicValue primValue,
                                        java.lang.CharSequence lexicalValue,
                                        boolean validate)

  Factory method to create values of a derived atomic type. This method is not used to create values of a built-in type, even one that is not primitive.

  Specified by:
    `makeDerivedValue` in interface `AtomicType`
  Parameters:
    `primValue` - the value in the value space of the primitive type
    `lexicalValue` - the value in the lexical space. If null, the string value of primValue
    `validate` - true if the value is to be validated against the facets of the derived type; false if the caller knows that the value is already valid.
  Returns:
    the derived atomic value if validation succeeds, or an ErrorValue otherwise. The ErrorValue encapsulates the exception that occurred; it is the caller's responsibility to check for this.

### analyzeContentExpression

    public void analyzeContentExpression(Expression expression,
                                         int kind,
                                         StaticContext env)
                                  throws XPathException

  Analyze an expression to see whether the expression is capable of delivering a value of this type.

  Specified by:
    `analyzeContentExpression` in interface `SchemaType`
  Parameters:
    `expression` - the expression that delivers the content
    `kind` - the node kind whose content is being delivered: `Type.ELEMENT`, `Type.ATTRIBUTE`, or `Type.DOCUMENT`
    `env` -
  Throws:
    `XPathException` - if the expression will never deliver a value of the correct type

### analyzeContentExpression

    public static void analyzeContentExpression(SimpleType simpleType,
                                                Expression expression,
                                                StaticContext env,
                                                int kind)
                                         throws XPathException

  Analyze an expression to see whether the expression is capable of delivering a value of this type.

  Parameters:
    `simpleType` - the simple type against which the expression is to be checked
    `expression` - the expression that delivers the content
    `kind` - the node kind whose content is being delivered: `Type.ELEMENT`, `Type.ATTRIBUTE`, or `Type.DOCUMENT`
  Throws:
    `XPathException` - if the expression will never deliver a value of the correct type

### getJavaClass

    public java.lang.Class getJavaClass()

### isBuiltIn

    public boolean isBuiltIn()

### matchesItem

    public boolean matchesItem(Item item,
                               XPathContext context,
                               boolean allowURIPromotion)

  Description copied from interface: `ItemType`
  Test whether a given item conforms to this type

  Specified by:
    `matchesItem` in interface `ItemType`
  Parameters:
    `item` - The item to be tested
    `context` -
    `allowURIPromotion` -
  Returns:
    true if the item is an instance of this type; false otherwise

### validateContent

    public ValidationException validateContent(java.lang.CharSequence value,
                                               NamespaceResolver nsResolver,
                                               NameChecker nameChecker)

  Check whether a given input string is valid according to this SimpleType

  Specified by:
    `validateContent` in interface `SimpleType`
  Parameters:
    `value` - the input string to be checked
    `nsResolver` - a namespace resolver used to resolve namespace prefixes if the type is namespace sensitive. The value supplied may be null; in this case any namespace-sensitive content will throw an UnsupportedOperationException.
    `nameChecker` -
  Returns:
    null if validation succeeds; return a ValidationException describing the validation failure if validation fails, unless throwException is true, in which case the exception is thrown rather than being returned.
  Throws:
    `java.lang.UnsupportedOperationException` - if the type is namespace-sensitive and no namespace resolver is supplied

### getSuperType

    public ItemType getSuperType(TypeHierarchy th)

  Description copied from interface: `ItemType`
  Get the type from which this item type is derived by restriction. This is the supertype in the XPath type heirarchy, as distinct from the Schema base type: this means that the supertype of xs:boolean is xdt:anyAtomicType, whose supertype is item() (rather than xs:anySimpleType).

  In fact the concept of "supertype" is not really well-defined, because the types form a lattice rather than a hierarchy. The only real requirement on this function is that it returns a type that strictly subsumes this type, ideally as narrowly as possible.

  Specified by:
    `getSuperType` in interface `ItemType`
  Parameters:
    `th` -
  Returns:
    the supertype, or null if this type is item()

### getFingerprint

    public int getFingerprint()

  Description copied from interface: `SchemaType`
  Get the fingerprint of the name of this type

  Specified by:
    `getFingerprint` in interface `SchemaType`
  Returns:
    the fingerprint. Returns an invented fingerprint for an anonymous type.

### toString

    public java.lang.String toString()

### getDisplayName

    public java.lang.String getDisplayName()

  Description copied from interface: `SchemaType`
  Get the display name of the type: that is, a lexical QName with an arbitrary prefix

  Specified by:
    `getDisplayName` in interface `SchemaType`
  Returns:
    a lexical QName identifying the type

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD